// MP3 Tag Converter
// Written by David J. Stein, Winter 2004. See "License.html" for terms and conditions of use.
//
// This module contains the code for a helper class that provides a list of possible track data sets and allows the user to choose one.

#region Using declarations

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

#endregion

namespace MP3TagConverterNS {

	public class ChooseFilenameParseSolution : System.Windows.Forms.Form	{

		#region Variables and initialization code

		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.ListView lstSolutions;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.ColumnHeader columnHeader5;
		private System.Windows.Forms.ColumnHeader columnHeader6;
		private System.Windows.Forms.ColumnHeader columnHeader7;
		private System.ComponentModel.Container components = null;
		public int iSelectedSolution = -1;

		public ChooseFilenameParseSolution(ArrayList strTokens, ArrayList aSolutions)	{
			InitializeComponent();
			lstSolutions.BeginUpdate();
			foreach (string strSolution in aSolutions) {
				string strTitle = "";
				string strAlbum = "";
				string strArtist = "";
				string strComment = "";
				string strYear = "";
				string strTrackNumber = "";
				string strGenre = "";
				string[] strArray = new string[strSolution.Length];
				for (int i = 0; i < strSolution.Length; i++) {
					char c = strSolution[i];
					if (c == 'R')
						strArtist = (string) strTokens[i];
					else if (c == 'T')  // title
						strTitle = (string) strTokens[i];
					else if (c == 'A')
						strAlbum = (string) strTokens[i];
					else if (c == '#')
						strTrackNumber = (string) strTokens[i];
					else if (c == 'Y')
						strYear = (string) strTokens[i];
					else if (c == 'G')
						strGenre = (string) strTokens[i];
					else if (c == 'C') {  // add all remaining items
						strComment = (string) strTokens[i++];
						while (i < strTokens.Count)
							strComment += " " + strTokens[i++];
					}
				}
				lstSolutions.Items.Add(new ListViewItem(new string[] { strArtist, strTitle, strAlbum, strTrackNumber, strYear, strGenre, strComment }));
			}
			lstSolutions.EndUpdate();
		}

		#region Uninteresting Windows Form Designer generated code
		protected override void Dispose(bool disposing)		{
			if (disposing) {
				if (components != null) {
				components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

	private void InitializeComponent()	{
		this.lstSolutions = new System.Windows.Forms.ListView();
		this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
		this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
		this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
		this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
		this.columnHeader5 = new System.Windows.Forms.ColumnHeader();
		this.columnHeader6 = new System.Windows.Forms.ColumnHeader();
		this.columnHeader7 = new System.Windows.Forms.ColumnHeader();
		this.label1 = new System.Windows.Forms.Label();
		this.btnOK = new System.Windows.Forms.Button();
		this.SuspendLayout();
		// 
		// lstSolutions
		// 
		this.lstSolutions.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																												this.columnHeader1,
																												this.columnHeader2,
																												this.columnHeader3,
																												this.columnHeader4,
																												this.columnHeader5,
																												this.columnHeader6,
																												this.columnHeader7});
		this.lstSolutions.FullRowSelect = true;
		this.lstSolutions.Location = new System.Drawing.Point(8, 40);
		this.lstSolutions.Name = "lstSolutions";
		this.lstSolutions.Size = new System.Drawing.Size(544, 104);
		this.lstSolutions.TabIndex = 0;
		this.lstSolutions.View = System.Windows.Forms.View.Details;
		this.lstSolutions.SelectedIndexChanged += new System.EventHandler(this.lstSolutions_SelectedIndexChanged);
		// 
		// columnHeader1
		// 
		this.columnHeader1.Text = "Artist";
		// 
		// columnHeader2
		// 
		this.columnHeader2.Text = "Title";
		this.columnHeader2.Width = 78;
		// 
		// columnHeader3
		// 
		this.columnHeader3.Text = "Album";
		// 
		// columnHeader4
		// 
		this.columnHeader4.Text = "Track";
		// 
		// columnHeader5
		// 
		this.columnHeader5.Text = "Year";
		// 
		// columnHeader6
		// 
		this.columnHeader6.Text = "Genre";
		// 
		// columnHeader7
		// 
		this.columnHeader7.Text = "Comment";
		this.columnHeader7.Width = 141;
		// 
		// label1
		// 
		this.label1.Location = new System.Drawing.Point(72, 16);
		this.label1.Name = "label1";
		this.label1.Size = new System.Drawing.Size(416, 23);
		this.label1.TabIndex = 1;
		this.label1.Text = "Multiple filename matches possible. Please select one from the following list:";
		this.label1.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
		// 
		// btnOK
		// 
		this.btnOK.Location = new System.Drawing.Point(243, 152);
		this.btnOK.Name = "btnOK";
		this.btnOK.TabIndex = 2;
		this.btnOK.Text = "OK";
		this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
		// 
		// ChooseFilenameParseSolution
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(560, 182);
		this.Controls.Add(this.btnOK);
		this.Controls.Add(this.label1);
		this.Controls.Add(this.lstSolutions);
		this.MaximizeBox = false;
		this.MinimizeBox = false;
		this.Name = "ChooseFilenameParseSolution";
		this.Text = "Choose MP3 Field Items";
		this.ResumeLayout(false);

	}
		#endregion

		#endregion

		#region Event handlers

		private void btnOK_Click(object sender, System.EventArgs e) {
			DialogResult = DialogResult.OK;
			Close();
		}

		private void lstSolutions_SelectedIndexChanged(object sender, System.EventArgs e) {
			if (lstSolutions.SelectedIndices.Count > 0)
				iSelectedSolution = lstSolutions.SelectedIndices[0];
		}

		#endregion

	}
}
