// MP3 Tag Converter
// Written by David J. Stein, Winter 2004. See "License.html" for terms and conditions of use.
//
// This module contains the documentation dialog for the MP3 Tag Converter tool.

#region Using declarations

using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.IO;
using System.Windows.Forms;

#endregion

namespace MP3TagConverterNS {

	public class HelpDialog : System.Windows.Forms.Form	{

		#region Variables, initialization code, and Main

		private System.Windows.Forms.Button btnOK;
		private System.Windows.Forms.TextBox txtHelp;
		private System.ComponentModel.Container components = null;

		public HelpDialog()	{
			InitializeComponent();
		}

		#region Uninteresting Windows Form Designer generated code
		protected override void Dispose(bool disposing)		{
			if (disposing) {
				if (components != null) {
				components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

	private void InitializeComponent()	{
		this.txtHelp = new System.Windows.Forms.TextBox();
		this.btnOK = new System.Windows.Forms.Button();
		this.SuspendLayout();
		// 
		// txtHelp
		// 
		this.txtHelp.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
			| System.Windows.Forms.AnchorStyles.Left) 
			| System.Windows.Forms.AnchorStyles.Right)));
		this.txtHelp.Location = new System.Drawing.Point(8, 8);
		this.txtHelp.Multiline = true;
		this.txtHelp.Name = "txtHelp";
		this.txtHelp.ReadOnly = true;
		this.txtHelp.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
		this.txtHelp.Size = new System.Drawing.Size(472, 328);
		this.txtHelp.TabIndex = 1;
		this.txtHelp.Text = "";
		// 
		// btnOK
		// 
		this.btnOK.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
		this.btnOK.Location = new System.Drawing.Point(207, 344);
		this.btnOK.Name = "btnOK";
		this.btnOK.TabIndex = 0;
		this.btnOK.Text = "OK";
		this.btnOK.Click += new System.EventHandler(this.btnOK_Click);
		// 
		// HelpDialog
		// 
		this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
		this.ClientSize = new System.Drawing.Size(488, 374);
		this.Controls.Add(this.btnOK);
		this.Controls.Add(this.txtHelp);
		this.Name = "HelpDialog";
		this.Text = "MP3 Tag Converter Help";
		this.Load += new System.EventHandler(this.HelpDialog_Load);
		this.ResumeLayout(false);

	}
		#endregion

		#endregion

		#region Event handlers

		private void HelpDialog_Load(object sender, System.EventArgs e) {
			string s = "MP3 Tag Converter Help.txt";
			if (File.Exists(s)) {
				StreamReader stream = new StreamReader(s);
				txtHelp.Text  = stream.ReadToEnd();
				stream.Close();
			} else {
				txtHelp.Text = "Couldn't find help documentation.";
			}
		}

		private void btnOK_Click(object sender, System.EventArgs e) {
			Close();
		}

		#endregion

	}
}
